unit Lab;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, PLab, ImgList, ActnList, ComCtrls, ColorGrd, ExtCtrls, ToolWin, PLTypes,
  StdCtrls;

type
  TLabForm = class(TForm)
    PLLab1: TPLLab;
    ActionList1: TActionList;
    EditCut: TAction;
    EditCopy: TAction;
    Selection: TAction;
    FileSave: TAction;
    FileSaveAs: TAction;
    FilePrint: TAction;
    InsertText: TAction;
    InsertLine: TAction;
    InsertBarCode: TAction;
    InsertImage: TAction;
    PropBack: TAction;
    PropPrint: TAction;
    PropData: TAction;
    FileClose: TAction;
    InsertSimbol: TAction;
    InsertAdTxt: TAction;
    InsertPar: TAction;
    InsertRect: TAction;
    PropDim: TAction;
    FilePreview: TAction;
    EditPaste: TAction;
    EditDelete: TAction;
    EditClear: TAction;
    EditPropElement: TAction;
    EditTransparent: TAction;
    EditFront: TAction;
    EditBack: TAction;
    EditAlignLeft: TAction;
    EditAlignTop: TAction;
    ImageList1: TImageList;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    TBFileSave: TToolButton;
    TBFilePrint: TToolButton;
    TBFilePreview: TToolButton;
    ToolButton7: TToolButton;
    TBSelect: TToolButton;
    TBDelete: TToolButton;
    TBText: TToolButton;
    TBLine: TToolButton;
    TBAddText: TToolButton;
    TBBarCode: TToolButton;
    TBRect: TToolButton;
    TBPara: TToolButton;
    TBImage: TToolButton;
    TBSymbol: TToolButton;
    ToolButton12: TToolButton;
    TBProp: TToolButton;
    Panel1: TPanel;
    ColorGrid1: TColorGrid;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Guardar1: TMenuItem;
    GuardarComo1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    Imprimir1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Editar1: TMenuItem;
    Cortar1: TMenuItem;
    Copiar1: TMenuItem;
    Pegar1: TMenuItem;
    N3: TMenuItem;
    Borrar1: TMenuItem;
    BorrarTodo1: TMenuItem;
    Insertar1: TMenuItem;
    Texto1: TMenuItem;
    TextoCompuesto1: TMenuItem;
    Linea1: TMenuItem;
    Smbolo1: TMenuItem;
    Rectngulo1: TMenuItem;
    Image1: TMenuItem;
    Prrafo1: TMenuItem;
    CodigoBarras1: TMenuItem;
    Propiedades1: TMenuItem;
    Dimensiones1: TMenuItem;
    Impresin1: TMenuItem;
    BaseDatos1: TMenuItem;
    N4: TMenuItem;
    BaseDatos2: TMenuItem;
    N7: TMenuItem;
    ExtractMeasure: TAction;
    Extraermedidas1: TMenuItem;
    PopupZoom: TPopupMenu;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N2001: TMenuItem;
    N4001: TMenuItem;
    TBZoom: TToolButton;
    ToolButton1: TToolButton;
    PopupMenu1: TPopupMenu;
    Borrar2: TMenuItem;
    Propiedades2: TMenuItem;
    Transparente1: TMenuItem;
    N5: TMenuItem;
    Traeralfrente1: TMenuItem;
    Enviaralfondo1: TMenuItem;
    N6: TMenuItem;
    Alinearizquierda1: TMenuItem;
    Alineararriba1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    Unidades1: TMenuItem;
    Milmetros1: TMenuItem;
    Pulgadas1: TMenuItem;
    procedure CheckZoom;
    procedure Ini(New:boolean;Name:string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FileCloseExecute(Sender: TObject);
    procedure uno1Click(Sender: TObject);
    procedure PLLab1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ColorGrid1Change(Sender: TObject);
    procedure InsertTextExecute(Sender: TObject);
    procedure InsertLineExecute(Sender: TObject);
    procedure InsertBarCodeExecute(Sender: TObject);
    procedure InsertImageExecute(Sender: TObject);
    procedure InsertRectExecute(Sender: TObject);
    procedure InsertSimbolExecute(Sender: TObject);
    procedure InsertAdTxtExecute(Sender: TObject);
    procedure InsertParExecute(Sender: TObject);
    procedure EditCutExecute(Sender: TObject);
    procedure EditCopyExecute(Sender: TObject);
    procedure EditPasteExecute(Sender: TObject);
    procedure EditDeleteExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditClearExecute(Sender: TObject);
    procedure PropDimExecute(Sender: TObject);
    procedure PropBackExecute(Sender: TObject);
    procedure PropPrintExecute(Sender: TObject);
    procedure PropDataExecute(Sender: TObject);
    procedure ExtractMeasureExecute(Sender: TObject);
    procedure N501Click(Sender: TObject);
    procedure N751Click(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    procedure N2001Click(Sender: TObject);
    procedure N4001Click(Sender: TObject);
    procedure PLLab1RightMouse(Sender: TObject; select: Boolean; X,
      Y: Integer);
    procedure EditTransparentExecute(Sender: TObject);
    procedure EditPropElementExecute(Sender: TObject);
    procedure EditFrontExecute(Sender: TObject);
    procedure EditBackExecute(Sender: TObject);
    procedure EditAlignLeftExecute(Sender: TObject);
    procedure EditAlignTopExecute(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FileSaveAsExecute(Sender: TObject);
    procedure FilePrintExecute(Sender: TObject);
    procedure FilePreviewExecute(Sender: TObject);
    procedure SelectionExecute(Sender: TObject);
    procedure Milmetros1Click(Sender: TObject);
    procedure Pulgadas1Click(Sender: TObject);
    procedure PLLab1Select(Sender: TObject);
  private
    Modified: Boolean;
  public
    FileName: string;
    function SaveChanges: Boolean;
    function Save: Boolean;
    function SaveAs: Boolean;
  end;

var
  LabForm: TLabForm;

implementation

uses Selec;

{$R *.DFM}

procedure TLabForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caFree;
end;

procedure TLabForm.Ini(New:boolean;Name:string);
begin
 if New then
  begin
   Modified:= false;
   FileName:= 'Untitled.eti';
   PlLab1.Clear;
  end else
  begin
   Modified:= false;
   FileName:= Name;
   PlLab1.LoadLab(Name);
  end;
 Caption:= FileName;
 StatusBar1.Panels[2].Text:= '  '+FileName;
 CheckZoom;
 if PlLab1.Units = unMM then Milmetros1.Checked:= true else Pulgadas1.Checked:= true;
end;

function TLabForm.SaveChanges: Boolean;
begin
 case MessageDlg('La etiqueta '+FileName+' ha cambiado.'+#13#13+'Desea conservar los cambios?',
      mtConfirmation, mbYesNoCancel,0) of
      idYes: Result:= Save;
      idNo : Result:= True;
     else
      Result:= False;
 end;
end;

function TLabForm.Save: Boolean;
begin
 if FileName = 'Untitled.eti' then
  Result:= SaveAs
 else
 begin
  PlLab1.SaveLab(FileName);
  Modified:= false;
  result:= true;
 end;
end;

function TLabForm.SaveAs: Boolean;
begin
 SaveDialog1.FileName:= FileName;
 if SaveDialog1.Execute then
  begin
   FileName:= SaveDialog1.FileName;
   StatusBar1.Panels[2].Text:= '  '+FileName;
   Caption:= FileName;
   Save;
   result:= true;
  end
  else
   result:= false;
end;

procedure TLabForm.FormCreate(Sender: TObject);
begin
 StatusBar1.DoubleBuffered:= true;
end;

procedure TLabForm.FileCloseExecute(Sender: TObject);
begin
 if not Modified or SaveChanges then Close;
end;

procedure TLabForm.uno1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
   begin
    FileName:= OpenDialog1.FileName;
    PlLab1.LoadLab(FileName);
    Modified:= false;
    StatusBar1.Panels[2].Text:= '  '+FileName;
   end;
end;

procedure TLabForm.PLLab1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 StatusBar1.Panels[0].Text:= ' X: '+ FloatToStrF(PlLab1.Worldx(X),ffFixed,4,2)+'  Y: '+ FloatToStrF(PlLab1.Worldy(Y),ffFixed,4,2);
end;

procedure TLabForm.ColorGrid1Change(Sender: TObject);
begin
 if PlLab1.Select <> nil then
  begin
   PlLab1.Select.Color:= ColorGrid1.ForegroundColor;
   PlLab1.Select.BackColor:= ColorGrid1.BackgroundColor;
   PlLab1.AdjustHandle;
  end;
end;

procedure TLabForm.InsertTextExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwText;
 Modified:= true;
end;

procedure TLabForm.InsertLineExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwLine;
 Modified:= true;
end;

procedure TLabForm.InsertBarCodeExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwBarCode;
 Modified:= true;
end;

procedure TLabForm.InsertImageExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwImage;
 Modified:= true;
end;

procedure TLabForm.InsertRectExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwRect;
 Modified:= true;
end;

procedure TLabForm.InsertSimbolExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwSymbol;
 Modified:= true;
end;

procedure TLabForm.InsertAdTxtExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwAddText;
 Modified:= true;
end;

procedure TLabForm.InsertParExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwParagraph;
 Modified:= true;
end;

procedure TLabForm.EditCutExecute(Sender: TObject);
begin
 PlLab1.CutElement;
end;

procedure TLabForm.EditCopyExecute(Sender: TObject);
begin
  PlLab1.CopyElement;
end;

procedure TLabForm.EditPasteExecute(Sender: TObject);
begin
 PlLab1.PasteElement;
end;

procedure TLabForm.EditDeleteExecute(Sender: TObject);
begin
 if (MessageDlg('Desea borrar el elemento?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
  begin
    PlLab1.DeleteElement;
  end;
end;

procedure TLabForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key=VK_DELETE) then EditDeleteExecute(Self);
end;

procedure TLabForm.EditClearExecute(Sender: TObject);
begin
 if (MessageDlg('Desea borrar todos los elementos?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
  begin
    PlLab1.Clear;
  end;
end;

procedure TLabForm.PropDimExecute(Sender: TObject);
begin
 PlLab1.ShowProp(0);
end;

procedure TLabForm.PropPrintExecute(Sender: TObject);
begin
 PlLab1.ShowProp(1);
end;

procedure TLabForm.PropBackExecute(Sender: TObject);
begin
 PlLab1.ShowProp(2);
end;

procedure TLabForm.PropDataExecute(Sender: TObject);
begin
  PlLab1.ShowProp(3);
end;

procedure TLabForm.ExtractMeasureExecute(Sender: TObject);
begin
 FormLabs:= TFormLabs.Create(Application);
  try
    FormLabs.FPlLab:= PlLab1;
    FormLabs.ShowModal;
  finally
    FormLabs.Free;
  end;
end;

procedure TLabForm.CheckZoom;
begin
 case PlLab1.Zoom of
   zm50:N501.Checked:= true;
   zm75:N751.Checked:= true;
  zm100:N1001.Checked:= true;
  zm200:N2001.Checked:= true;
  zm400:N4001.Checked:= true;
 end;
end;

procedure TLabForm.N501Click(Sender: TObject);
begin
 N501.Checked:= true;
 PlLab1.Zoom:= zm50;
end;

procedure TLabForm.N751Click(Sender: TObject);
begin
 N751.Checked:= true;
 PlLab1.Zoom:= zm75;
end;

procedure TLabForm.N1001Click(Sender: TObject);
begin
 N1001.Checked:= true;
 PlLab1.Zoom:= zm100;
end;

procedure TLabForm.N2001Click(Sender: TObject);
begin
 N2001.Checked:= true;
 PlLab1.Zoom:= zm200;
end;

procedure TLabForm.N4001Click(Sender: TObject);
begin
 N4001.Checked:= true;
 PlLab1.Zoom:= zm400;
end;

procedure TLabForm.PLLab1RightMouse(Sender: TObject; select: Boolean; X,
  Y: Integer);
var
 Position: TPoint;
begin
 if select then
  begin
   Position.x:= X;
   Position.y:= Y;
   Position:= ClientToScreen(Position);
   PopupMenu1.Popup(Position.X+PLLab1.Left,Position.Y+PLLab1.Top);
  end else
  begin
   SelectionExecute(Self);
   TBSelect.Down:= true;
  end;
end;

procedure TLabForm.EditTransparentExecute(Sender: TObject);
begin
 Transparente1.Checked:= not Transparente1.Checked;
 PlLab1.Transparent;
end;

procedure TLabForm.EditPropElementExecute(Sender: TObject);
begin
  PlLab1.ShowElementProp;
end;

procedure TLabForm.EditFrontExecute(Sender: TObject);
begin
 PlLab1.Front;
end;

procedure TLabForm.EditBackExecute(Sender: TObject);
begin
 PlLab1.Back;
end;

procedure TLabForm.EditAlignLeftExecute(Sender: TObject);
begin
 PlLab1.AlignLeft;
end;

procedure TLabForm.EditAlignTopExecute(Sender: TObject);
begin
 PlLab1.AlignTop;
end;

procedure TLabForm.PopupMenu1Popup(Sender: TObject);
begin
 if PlLab1.Select <> nil then
  begin
   Transparente1.Checked := (PlLab1.Select As TPLElement).Transparent;
  end;
end;

procedure TLabForm.FileSaveExecute(Sender: TObject);
begin
 if Modified then Save;
end;

procedure TLabForm.FileSaveAsExecute(Sender: TObject);
begin
 SaveAs;
end;

procedure TLabForm.FilePrintExecute(Sender: TObject);
begin
 if PrintDialog1.Execute then
  begin
   PlLab1.Print;
  end;
end;

procedure TLabForm.FilePreviewExecute(Sender: TObject);
begin
 PlLab1.Preview;
end;

procedure TLabForm.SelectionExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crDefault;
 PlLab1.DrawTool:= dwSelection;
end;

procedure TLabForm.Milmetros1Click(Sender: TObject);
begin
 PlLab1.Units:= unMM;
 Milmetros1.Checked:= true;
end;

procedure TLabForm.Pulgadas1Click(Sender: TObject);
begin
 PlLab1.Units:= unINCH;
 Pulgadas1.Checked:= true;
end;

procedure TLabForm.PLLab1Select(Sender: TObject);
var
 w,h: single;
begin
 if PlLab1.Select is TPLImage then
  begin
   w:= PlLab1.Select.P2.x - PlLab1.Select.P1.x;
   h:= PlLab1.Select.P2.y - PlLab1.Select.P1.y;
   StatusBar1.Panels[1].Text:= ' Width: '+ FloatToStrF(w,ffFixed,4,2)+'  Height: '+ FloatToStrF(h,ffFixed,4,2);
  end;
end;

end.













